(* Analyse syntaxique et valuation d'expression algbrique infixe avec priorit et parenthsage *)

#open "genlex";;

(* Types pour la table de valeurs des variables *)
type valeur = NoVal | Value of int ;;
type variable = {Nom: string; Valeur: valeur} ;;

(* Type pour l'arbre d'valuation *)
type Elt = Egal | Plus | Moins | Mult | Div | Val of int | Var of string ;;
type arbre = 
    Nil
  | Noeud of arbre * Elt * arbre
;;

(* Transformation d'un flux en liste *)
let rec list_of_stream = function
	| [< 't; list_of_stream q >] -> t::q
	| [< >] -> []
;;

(* Lit les expressions dans un fichier et leur applique la fonction d'analyse syntaxique qui doit
   tre du type (an_syn: token list -> bool * token list). *)
let analyse_file (an_syn: variable list -> token list -> bool * variable list * arbre * token list) fichier =
  let canal = open_in fichier
  and raccourci s = agreg_ident (list_of_stream (make_lexer ["=";"+";"-";"*";"/";"(";")";"#"] (stream_of_string s)))
  and ligne = ref [] and result = ref (true, [], Nil, []) and test = ref true and liste_var = ref []
  in 
    while !test do
      (try ligne := raccourci ((input_line canal)^" #") with End_of_file -> test := false) ;
      if (!test) then
        begin
          result := an_syn (!liste_var) !ligne ;
          print_string (string_of_toklist !ligne); print_newline();
	       begin
            match !result with
	           | false, _, _, r -> 
		            print_string ("L'expression est incorrecte  partir de "^(string_of_toklist r))
	           | true, l_var, arb, _ -> 
		            print_string "L'expression est correcte et vaut " ;
		            try let (val_x, tmp) = eval_arbre l_var arb in
		              begin
			             print_int val_x ; print_char `.` ;
			             liste_var := tmp
		              end;
		            with 
		                Uninit_Var -> print_string "... Variable non initialise"
		              | Undef_Var ->  print_string "... Variable non dfinie"
	       end;
          print_newline(); 
        end;
    done;
    affiche_liste !liste_var ;
    close_in canal
;;

analyse_file lit_ligne "C:\Documents and Settings\Mathieu\Mes documents\Colles_CaML\Colle06\validat1.don";;
